#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "utils_phy.h"
#include "utils_stn.h"

extern WlanStn_t *pWlanStnHEAD;

int main (int argc, char *argv[]) {
// PHY
#if 0
    int sts;
    unsigned char *c;

    WlanPhy_t wphy;

    sts = get_phy_info(0, &wphy);

    printf("h4aWlanPhyName:       %s\n", wphy.h4aWlanPhyName);
    printf("h4aWlanPhyName_len:   %i\n", wphy.h4aWlanPhyName_len);
    c=wphy.h4aWlanPhyMac;
    printf("h4aWlanPhyMac:        %2.2x:%2.2x:%2.2x:%2.2x:%2.2x:%2.2x\n",
    c[0], c[1], c[2], c[3], c[4], c[5]);
    printf("h4aWlanPhyMac_len:    %i\n", wphy.h4aWlanPhyMac_len);
    printf("h4aWlanPhyNoisefloor: %i\n", wphy.h4aWlanPhyNoisefloor);
    printf("h4aWlanPhyTxPower:    %i\n", wphy.h4aWlanPhyTxPower);
    printf("h4aWlanPhyBandwidth:  %i\n", wphy.h4aWlanPhyBandwidth);
#endif

// STN
    int sts;
//    int len;
//    int i;
    WlanStn_t *ptr=NULL;
    WlanStn_t stn;
//    char buffer[64];
//    char *b;
//    char *n;
//    FILE *f;

while (1) {
    ptr=NULL;
    while ((ptr = get_next_stn_record(ptr)) != NULL) {
        printf("0: wstn ptr=%p\n",ptr);
    }


    sts = update_stn_records();


strcpy(stn.h4aWlanStnIfName, "wlan1");
strcpy(stn.h4aWlanStnMacLocal, "123");
strcpy(stn.h4aWlanStnMacRemote, "abc");
stn.h4aWlanStnRxLevel=-43;
stn.h4aWlanStnTxRate=123456;
sts = insert_stn_record(1, &stn);

strcpy(stn.h4aWlanStnIfName, "wlan1");
strcpy(stn.h4aWlanStnMacLocal, "234");
strcpy(stn.h4aWlanStnMacRemote, "cde");
stn.h4aWlanStnRxLevel=-60;
stn.h4aWlanStnTxRate=123456;
sts = insert_stn_record(1, &stn);

strcpy(stn.h4aWlanStnIfName, "wlan1");
strcpy(stn.h4aWlanStnMacLocal, "123");
strcpy(stn.h4aWlanStnMacRemote, "abc");
stn.h4aWlanStnRxLevel=-48;
stn.h4aWlanStnTxRate=123456;
sts = insert_stn_record(1, &stn);

strcpy(stn.h4aWlanStnIfName, "wlan2");
strcpy(stn.h4aWlanStnMacLocal, "345");
strcpy(stn.h4aWlanStnMacRemote, "cde");
stn.h4aWlanStnRxLevel=-77;
stn.h4aWlanStnTxRate=222222;
sts = insert_stn_record(2, &stn);

strcpy(stn.h4aWlanStnIfName, "wlan0");
strcpy(stn.h4aWlanStnMacLocal, "456");
strcpy(stn.h4aWlanStnMacRemote, "def");
stn.h4aWlanStnRxLevel=-66;
stn.h4aWlanStnTxRate=33333;
sts = insert_stn_record(0, &stn);

/*
typedef struct WlanStn_s {
/    void *next;					// ptr to next element
/    int  active;				// 
/    int  h4aWlanStnIndex;
/    #define LEN_WLANSTNNAME 32
/    char h4aWlanStnIfName[LEN_WLANSTNNAME];
    #define LEN_WLANSTNMAC MACLEN
    char h4aWlanStnMacLocal[LEN_WLANSTNMAC];
    char h4aWlanStnMacRemote[LEN_WLANSTNMAC];
    int  h4aWlanStnRxLevel;
    int  h4aWlanStnTxRate;
} WlanStn_t;
*/


    ptr=NULL;
    while ((ptr = get_next_stn_record(ptr)) != NULL) {
        printf("2: ptr=%p  ",ptr);
        printf("%i:%i:%s [%x:%x:%x:%x:%x:%x] [%x:%x:%x:%x:%x:%x] - %i:%i\n",
        ptr->active,ptr->h4aWlanStnIndex,
        ptr->h4aWlanStnIfName,
        ptr->h4aWlanStnMacLocal[0]&0xff,ptr->h4aWlanStnMacLocal[1]&0xff,
        ptr->h4aWlanStnMacLocal[2]&0xff,ptr->h4aWlanStnMacLocal[3]&0xff,
        ptr->h4aWlanStnMacLocal[4]&0xff,ptr->h4aWlanStnMacLocal[5]&0xff,
        ptr->h4aWlanStnMacRemote[0]&0xff,ptr->h4aWlanStnMacRemote[1]&0xff,
        ptr->h4aWlanStnMacRemote[2]&0xff,ptr->h4aWlanStnMacRemote[3]&0xff,
        ptr->h4aWlanStnMacRemote[4]&0xff,ptr->h4aWlanStnMacRemote[5]&0xff,
        ptr->h4aWlanStnRxLevel,ptr->h4aWlanStnTxRate);
    }

invalidate_stn_records();

    ptr=NULL;
    while ((ptr = get_next_stn_record(ptr)) != NULL) {
        printf("3: ptr=%p  ",ptr);
        printf("%i:%i:%s [%x:%x:%x:%x:%x:%x] [%x:%x:%x:%x:%x:%x] - %i:%i\n",
        ptr->active,ptr->h4aWlanStnIndex,
        ptr->h4aWlanStnIfName,
        ptr->h4aWlanStnMacLocal[0]&0xff,ptr->h4aWlanStnMacLocal[1]&0xff,
        ptr->h4aWlanStnMacLocal[2]&0xff,ptr->h4aWlanStnMacLocal[3]&0xff,
        ptr->h4aWlanStnMacLocal[4]&0xff,ptr->h4aWlanStnMacLocal[5]&0xff,
        ptr->h4aWlanStnMacRemote[0]&0xff,ptr->h4aWlanStnMacRemote[1]&0xff,
        ptr->h4aWlanStnMacRemote[2]&0xff,ptr->h4aWlanStnMacRemote[3]&0xff,
        ptr->h4aWlanStnMacRemote[4]&0xff,ptr->h4aWlanStnMacRemote[5]&0xff,
        ptr->h4aWlanStnRxLevel,ptr->h4aWlanStnTxRate);
    }

strcpy(stn.h4aWlanStnIfName, "wlan1");
strcpy(stn.h4aWlanStnMacLocal, "123");
strcpy(stn.h4aWlanStnMacRemote, "abc");
stn.h4aWlanStnRxLevel=-48;
stn.h4aWlanStnTxRate=123456;
sts = insert_stn_record(1, &stn);

    ptr=NULL;
    while ((ptr = get_next_stn_record(ptr)) != NULL) {
        printf("4: ptr=%p  ",ptr);
        printf("%i:%i:%s [%x:%x:%x:%x:%x:%x] [%x:%x:%x:%x:%x:%x] - %i:%i\n",
        ptr->active,ptr->h4aWlanStnIndex,
        ptr->h4aWlanStnIfName,
        ptr->h4aWlanStnMacLocal[0]&0xff,ptr->h4aWlanStnMacLocal[1]&0xff,
        ptr->h4aWlanStnMacLocal[2]&0xff,ptr->h4aWlanStnMacLocal[3]&0xff,
        ptr->h4aWlanStnMacLocal[4]&0xff,ptr->h4aWlanStnMacLocal[5]&0xff,
        ptr->h4aWlanStnMacRemote[0]&0xff,ptr->h4aWlanStnMacRemote[1]&0xff,
        ptr->h4aWlanStnMacRemote[2]&0xff,ptr->h4aWlanStnMacRemote[3]&0xff,
        ptr->h4aWlanStnMacRemote[4]&0xff,ptr->h4aWlanStnMacRemote[5]&0xff,
        ptr->h4aWlanStnRxLevel,ptr->h4aWlanStnTxRate);
    }

usleep(100000);
}

return 0;
}
