#!/bin/bash
#
# 
# Copyright (C) 2011 HB9XAR
#

### Experimental

### Does not clean up possible old stuff!
### do it on your own or reboot before using this script


###
### Setup Proxy ARP Link: br-lan --[-- wifi --]-- br-wlan
###
[ -z "$R_NET" ]  && R_NET=192.168.2.104
[ -z "$R_MASK" ] && R_MASK=255.255.255.240
[ -z "$R_MASK" ] && NEXT_HOP=10.0.0.4

# calculate individual IPs from NET/MASK
if [ "$R_MASK" != "255.255.255.255" ]; then
   S=$(ipcalc.sh $R_NET $R_MASK 1 255 | grep START| cut -d '.' -f4)
   E=$(ipcalc.sh $R_NET $R_MASK 1 255 | grep END  | cut -d '.' -f4)
   P=$(echo $R_NET | cut -d'.' -f1-3)
   R_HOSTS=""
   for each in $(seq $S $E); do
      R_HOSTS="$R_HOSTS ${P}.$each"
   done
else
   R_HOSTS=$R_NET
fi

# enable proxy ARP on ETH bridge
echo -n 1 > /proc/sys/net/ipv4/conf/br-lan/proxy_arp

# add routing entry
route add -net ${R_NET} netmask ${R_MASK} gw ${NEXT_HOP}

# add ARP entry for proxied subnet (one entry for each host,
# netmasks are no longer supported for ARP entries :-( )
for each in $R_HOSTS; do
    arp -i br-lan -Ds ${each} br-lan pub
done

###
### End of Proxy ARP Setup
###
exit
