#!/bin/sh

# To be included in SNMP config (etc/config/snmpd):
# config exec
#        option execname temperature
#        option prog     /usr/bin/gettemp.sh
#        option args     
#        option miboid   1.3.6.1.3.999.1.1
#
# SNMPv2-SMI::experimental.999.1.1.1.1 = INTEGER: 1
# SNMPv2-SMI::experimental.999.1.1.2.1 = STRING: "temperature"
# SNMPv2-SMI::experimental.999.1.1.3.1 = STRING: "/usr/bin/gettemp.sh"
# SNMPv2-SMI::experimental.999.1.1.100.1 = INTEGER: 0
# SNMPv2-SMI::experimental.999.1.1.101.1 = STRING: "43.0"		Board Temp?
# SNMPv2-SMI::experimental.999.1.1.101.2 = STRING: "50.1"		CPU Temp
# SNMPv2-SMI::experimental.999.1.1.102.1 = INTEGER: 0
# SNMPv2-SMI::experimental.999.1.1.103.1 = ""

# Temperature in centigrades
/usr/sbin/sensors|grep temp | \
/bin/sed -e 's/temp.*: *+\([0-9]*\)\.\([0-9]*\).*/\1.\2/' | \
awk '{printf "%.2f\n",$1}'

