<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
   <head>
      <title>HAMNET System Summary</title>
   </head>
   <body bgcolor="#101060" text="#f0f0f0">
<H2>ALIX HAMNET Router</H2>
<?php

echo "<H3>Hardware/OS</H3>\n";

#-- Uptime
$uptime=shell_exec('uptime');
echo "System uptime:<pre>$uptime</pre>\n";
echo "<hr>\n";

#-- Temperature
$temp1=file_get_contents('/sys/class/hwmon/hwmon0/device/temp1_input')/1000.0;
$temp2=file_get_contents('/sys/class/hwmon/hwmon0/device/temp2_input')/1000.0;
echo "Temperature:";
echo "<pre>Ambient: ". $temp1 . " C, CPU core: ". $temp2 . " C</pre>\n";
echo "<hr>\n";

#-- uname
$uname=shell_exec('uname -a');
echo "Uname:<pre>$uname</pre>\n";
echo "<hr><hr>\n";

echo "<H3>Network (Layer 2)</H3>\n";

#-- Interface Config
$ifconfig=shell_exec('ifconfig');
echo "Interface Configuration:<pre>$ifconfig</pre>\n";

#-- WLAN Status
$wlan_stn=shell_exec('iw wlan0 station dump');
echo "WLAN Stations:<pre>$wlan_stn</pre>\n";
echo "<hr><hr>\n";

echo "<H3>Network (Layer 3)</H3>\n";

#-- IP Routes
$routes=shell_exec('route -n');
echo "IP routing:<pre>$routes</pre>\n";
echo "<hr>\n";

#-- BGP Summary
$bgpsum=shell_exec('export VTYSH_PAGER="/bin/cat"; echo "show ip bgp"|vtysh');
echo "BGP Summary:<pre>$bgpsum</pre>\n";
echo "<hr><hr>\n";

echo "<H3>Other System Data</H3>";
#-- DMESG output
$dmesg=shell_exec('dmesg|tail -20');
echo "Recent Kernel Messages:<pre>$dmesg</pre>";
echo "<hr>\n";

?>
</body>
</html>
